



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Linux内核分析作业五</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Linux内核分析作业五</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 19:47:48 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>扒开系统调用的三层皮（下）</h1>
<h2>给MenuOS增加time和time-asm命令</h2>
<p><strong>步骤</strong></p>
<ul><li>rm menu -rf //强制删除</li>
<li>git clone <a href="http://github.com/menging/menu.git" rel="external nofollow noreferrer">http://github.com/menging/menu.git</a> // 克隆相关信息到menu</li>
<li>cd menu</li>
<li>make rootfs //自动编译生成根文件系统，自动启动</li></ul>
<p><strong>如何给MenuOS增加命令</strong></p>
<pre class="prettyprint linenums"><code>更新menu代码到最新版<br />
在main函数中增加MenuConfig<br />
增加对应的函数<br />
make rootfs<br />
</code></pre>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/744533/201603/744533-20160324235015964-1965515308.jpg"></p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/744533/201603/744533-20160324235034042-946672236.jpg"></p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/744533/201603/744533-20160324235046339-9773265.jpg"></p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/744533/201603/744533-20160324235121995-2088559901.jpg"></p>
<h2>使用gdb跟踪系统调用内核函数sys_time</h2>
<pre class="prettyprint linenums"><code>1)qemu -kernel linux-3.18.6/arch/x86/bzImage -initrd rootfs.img -s -S<br />
2)gdb<br />
3)file linux-3.18.6/vmlinux<br />
4)target remote:1234<br />
5)设置断点<br />
6)使用s进行单步的运行<br />
</code></pre>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/744533/201603/744533-20160324235111542-1267982844.jpg"></p>
<h2>系统调用在内核代码中的处理过程</h2>
<h3>工作机制和初始化</h3>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/744533/201603/744533-20160324235134589-1299589954.jpg"></p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/744533/201603/744533-20160324235150120-1099720553.jpg"></p>
<h3>简化后便于理解的system_call伪代码</h3>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/744533/201603/744533-20160326092454933-57179251.jpg"></p>
<p>系统调用实际就是一种特殊的中断<br /><br />
<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/744533/201603/744533-20160324235205933-205072613.jpg"></p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/744533/201603/744533-20160324235222292-51491668.jpg"></p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/744533/201603/744533-20160324235234854-327905048.jpg"></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rqlnrk8o.html">热修复-Tinker</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx55y08.html">Swiper 中文API手册（share）</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p6zezq.html">gui学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqd7xxxq.html">Android-BaseLine基础性开发框架</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m1vzr8.html">【iOS开发】UIWebView与JavaScript&lpar;JS&rpar; 回调交互</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlznd18.html">PHP抓取采集类snoopy介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p1xxy9.html">SSH 基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x32nm8.html">&lbrack;无人值守安装操作系统&rsqb;&lowbar;FTP&plus;TFTP&plus;DHCP&plus;Kickstart&plus;PXE&lowbar;中遇到的错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1lzlx9.html">SAP Java Connector&lpar;JCo&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvm6r1q.html">ExtJs API 下载以及部署</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v31648.html">&lbrack;Javascript&rsqb; Refactoring&colon; Polymorphic Functions</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjl25y9.html">函数reduce&comma;lambda&comma;filter</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey3jpj9.html">沙盒单机网站代表-Steam【推荐】</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1ngwzq.html">发生Windows无法访问远程共享的解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpnlm7q.html">Java自学总结--简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mwrzo8.html">MySQL中count函数使用方法详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj00v59.html">nginx和php-fpm的进程启停重载总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvjolk8.html">Eclipse 新建 Maven web 项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o41zkpq.html">Vuex 入门指南</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rn07ymq.html">cocos2d-x中用到的一些宏</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qllx4d1q.html">Java引用类型转换</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2x07oq.html">&lbrack;Tomcat&rsqb;The JRE&lowbar;HOME environment variable is not defined correctly</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdwx76j9.html">django知识点回顾（上）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4xn1e9.html">python五十九课&mdash;&mdash;正则表达式的拓展内容</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4xnkk9.html">2018-2019-2 《网络对抗技术》Exp0 Kali安装 Week1 20165318</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o12z7eq.html">oracle 查询表中数据行&lpar;row&rpar;上最后的DML时间</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwvzpk8.html">win7下面搭建angularjs开发环境</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjk1ke9.html">centos 6&period;5 gogs迁移外部仓库报错</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7o3m3e8.html">Multi-View Region Adaptive Multi-temporal DMM and RGB Action Recognition</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5m55eq.html">WireShark抓包工具使用</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
